# Getting Started

## Registration

To use pid4cat services, organizations must apply to become a Sub-Name Assigning Authority (SNAA). The application process involves:

1. Submitting an application form to the pid4cat core organization (TODO add contact info)
2. Agreeing to the pid4cat policies (detailed in section [Policies](./policies.md))
3. Demonstrating the capability to maintain the identified resources
4. Designating a technical and administrative contact

Upon approval, the organization will receive:

- A unique namespace suffix (`<ns-suffix>`)
- API credentials for accessing the pid4cat API
- Documentation and support for the integration into SNAA-operated services

## Creating identifiers

Identifiers can be created through the pid4cat API. Partner organizations (SNAAs) have two options:

1. **Generated identifiers**: Identifiers generated by the pid4cat API
2. **Custom identifiers**: Identifiers created according to SNAA's naming conventions

!!! warning "The API URLs are not final."

    TODO: Update API urls below before Release 1.0.0.

To request a new identifier generated by pid4cat service:

```http
PUT https://api.nfdi4cat.org/testpid/v2/handles/<prefix>/<ns-suffix>/
```

To create a custom identifier: (Future!)

```http
PUT https://api.nfdi4cat.org/testpid/<version>?customid=xxx-xxx
```

With a payload containing:

- The local identifier (optional for opaque identifiers)
- The URL of the resource
- Required metadata according to the pid4cat-model

For detailed API documentation, see the [REST APIs](./apis.md#rest-apis) section.

## Updating identifiers

Identifiers and their associated metadata can be updated through the pid4cat API:

!!! warning "The API URLs are not final."

    TODO: Update API urls below before Release 1.0.0.

```http
PUT https://api.nfdi4cat.org/testpid/v2/handles/<prefix>/<ns-suffix>/<local-id>
```

Updates may include:

- Change of the target URL
- Additions or modifications to metadata

Note that the identifier itself cannot be changed once created.
Only its associated metadata and target URL can be modified.

## Resolving identifiers

pid4cat identifiers can be resolved using:

1. **Direct resolution**: `https://hdl.handle.net/<prefix>/<ns-suffix>/<local-id>`
2. **pid4cat resolver**: `https://pid.nfdi4cat.org/<prefix>/<ns-suffix>/<local-id>`
3. **pid4cat resolver**: `https://handle.nfdi4cat.org/<prefix>/<ns-suffix>/<local-id>`

Resolution will typically redirect to the landing page for the identified resource, which should be maintained by the responsible SNAA.
