---
title: **pid4cat Documentation**
---

![pid4cat logo](images/logo-with-text.svg#only-light)
![pid4cat logo](images/logo-with-text-dark.svg#only-dark)

**pid4cat** is a persistent identifier (PID) service designed and operated by NFDI4Cat for the catalysis research community.
The pid4cat service builds upon existing PID infrastructure (Handle System) while providing enhanced capabilities for metadata management and namespace delegation. It enables partner organizations to manage their own sub-namespaces while maintaining a consistent approach to PID metadata management via a LinkML-based model.

!!! warning "The model is work in progress."

    Please don't expect stability before Release 1.0.0. (TODO: Remove Warning)

- [Overview](./overview.md) on pid4cat identifiers
- [Schema documentation](./elements/overview.md) for the metadata model

The pid4cat documentation and model are developed on GitHub at [NFDI4Cat/pid4cat-model](https://github.com/nfdi4cat/pid4cat-model/).

## Benefits of using pid4cat

- **Distributed management**: Partner organizations can manage their own namespaces
- **Rich metadata**: Support for comprehensive, structured identifier-related metadata
- **Interoperability**: Compatible with existing PID systems and linked data principles.
- **Community standards**: Alignment with catalysis research community standards and practices

## Support

### Getting Help

- Use NFDI4Cat community [discussions](https://github.com/orgs/nfdi4cat/discussions?discussions_q=label%3Apid4cat+).

### Reporting Issues

- Report technical issues through the [GitHub repository](https://github.com/nfdi4cat/pid4cat-model/issues/).

### Contact

- For general enquiries or policy questions contact us via [nfdi4cat.org](https://nfdi4cat.org/en/contact/).
- For questions regarding the pid4cat-handle service you may directly contact [HLRS](mailto:handles@hlrs.de).
